#include "HAHead.hlsl"

#define BLENDDIFFUSE0TEXTUREFILENAME "diffuse_test01_02.png"
#define BLENDDIFFUSE1TEXTUREFILENAME "diffuse_test03.png"
//#define BLENDDIFFUSE2TEXTUREFILENAME "DiffuseMulBySat.png"
//#define BLENDSPECULAR0TEXTUREFILENAME "SpecularMul.png"
//#define BLENDADDSPHERE0TEXTUREFILENAME "AddSphereRepl.png"
#define BLENDEDGE0TEXTUREFILENAME
#define USE_EXCELLENTSHADOW
//#define SHADE_TOONLESS
//#define AMBIENT_AS_BASE
//#define AMBIENT_TOON_AS_BASE
#define HANDLE_EDGE
//#define FIX_LIGHTDIR
//#define FIX_SPHEREMAP
#ifdef BLENDDIFFUSE0TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, BLENDDIFFUSE0TEXTUREFILENAME)
#endif
#ifdef BLENDDIFFUSE1TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendDiffuse1Texture, BlendDiffuse1TextureSampler, BLENDDIFFUSE1TEXTUREFILENAME)
#endif
#ifdef BLENDDIFFUSE2TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendDiffuse2Texture, BlendDiffuse2TextureSampler, BLENDDIFFUSE2TEXTUREFILENAME)
#endif
#ifdef BLENDSPECULAR0TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendSpecular0Texture, BlendSpecular0TextureSampler, BLENDSPECULAR0TEXTUREFILENAME)
#endif
#ifdef BLENDADDSPHERE0TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendAddSphere0Texture, BlendAddSphere0TextureSampler, BLENDADDSPHERE0TEXTUREFILENAME)
#endif

float EdgeWidthRate
<
	string UIName = "GbW";
	float UIMin = 0;
	float UIMax = 2;
> = 0.7;

float3 BlendDiffuse0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE0TEXTUREFILENAME
	float4 value = tex2D(BlendDiffuse0TextureSampler, float2(parameters.LightNormal, 0));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse1(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE1TEXTUREFILENAME
	float4 value = tex2D(BlendDiffuse1TextureSampler, float2(parameters.HalfVectorNormal, 0));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse2(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE2TEXTUREFILENAME
	float3 targetHsv = GetHsvFromRgb(target);
	float4 value = tex2D(BlendDiffuse2TextureSampler, float2(parameters.LightNormal, targetHsv.y));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse(float3 color, BlendParameters parameters)
{
	color = BlendDiffuse0(color, parameters);
	color = BlendDiffuse1(color, parameters);
	color = BlendDiffuse2(color, parameters);

	return color;
}

float3 BlendSpecular0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDSPECULAR0TEXTUREFILENAME
	float4 value = tex2D(BlendSpecular0TextureSampler, float2(parameters.SpecularValue, 0));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendSpecular(float3 color, BlendParameters parameters)
{
	color = BlendSpecular0(color, parameters);

	return color;
}

float3 BlendAddSphere0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDADDSPHERE0TEXTUREFILENAME
	float3 targetHsv = GetHsvFromRgb(target);
	float4 value = tex2D(BlendAddSphere0TextureSampler, float2(targetHsv.z, 0));
	
	targetHsv.z = lerp(targetHsv.z, value.b, value.a);
	target = GetRgbFromHsv(targetHsv);
	#endif
	
	return target;
}

float3 BlendAddSphere(float3 color, BlendParameters parameters)
{
	color = BlendAddSphere0(color, parameters);

	return color;
}

float3 BlendEdge0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDEDGE0TEXTUREFILENAME
	float4 value = float4(0, 0, 0, 1);
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendEdge(float3 color, BlendParameters parameters)
{
	color = BlendEdge0(color, parameters);

	return color;
}

#include "HACore.hlsl"

// HAGenerator Document
// HA2 QA5FZmZlY3REb2N1bWVudAQVQ29weUNvcmVUb0Rlc3RpbmF0aW9umARUcnVlBAlFZGdlV2lkdGiY
// HA2 AzAuNwQRRml4TGlnaHREaXJlY3Rpb26YBUZhbHNlBAxGaXhTcGhlcmVNYXCYBUZhbHNlBApIYW5k
// HA2 bGVFZGdlmARUcnVlBBBTZXRBbWJpZW50QXNCYXNlmAVGYWxzZQQYU2V0QW1iaWVudEFzQmFzZVdp
// HA2 dGhUb29umAVGYWxzZQQNU2hhZGVUb29ubGVzc5gFRmFsc2UEElVzZUV4Y2VsbGVudFNoYWRvd5gE
// HA2 VHJ1ZQg5Y2xyLW5hbWVzcGFjZTpMaW5lYXJzdGFyLkhBR2VuZXJhdG9yO2Fzc2VtYmx5PUhBR2Vu
// HA2 ZXJhdG9yCQF4LGh0dHA6Ly9zY2hlbWFzLm1pY3Jvc29mdC5jb20vd2luZngvMjAwNi94YW1sQB9F
// HA2 ZmZlY3REb2N1bWVudC5BZGRTcGhlcmVFbnRyaWVzQApCbGVuZEVudHJ5BAlJc0VuYWJsZWSYBUZh
// HA2 bHNlBApJc1NwZWN1bGFymARUcnVlBApQYXJhbWV0ZXJYmAVWYWx1ZQQKUGFyYW1ldGVyWZgETm9u
// HA2 ZUASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0
// HA2 aW9uBARLaW5kmAROb25lBBBQYXJhbWV0ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyYA0h1
// HA2 ZQFAC0JsZW5kQWN0aW9uBARLaW5kmAROb25lBBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFy
// HA2 Z2V0Q2hhbm5lbJgKU2F0dXJhdGlvbgFAC0JsZW5kQWN0aW9uBARLaW5kmAdSZXBsYWNlBBBQYXJh
// HA2 bWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmAVWYWx1ZQEBAUASQmxlbmRFbnRyeS5U
// HA2 ZXh0dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWYEUFkZFNwaGVyZVJlcGwu
// HA2 cG5nBARLaW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgWQmxlbmRBZGRTcGhlcmUwVGV4dHVyZQEBAQFA
// HA2 HUVmZmVjdERvY3VtZW50LkRpZmZ1c2VFbnRyaWVzQApCbGVuZEVudHJ5BAlJc0VuYWJsZWSYBFRy
// HA2 dWUECklzU3BlY3VsYXKYBUZhbHNlBApQYXJhbWV0ZXJYmAtMaWdodE5vcm1hbAQKUGFyYW1ldGVy
// HA2 WZgETm9uZUASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25AC0Js
// HA2 ZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRD
// HA2 aGFubmVsmANSZWQBQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5u
// HA2 ZWyYBUdyZWVuBA1UYXJnZXRDaGFubmVsmAVHcmVlbgFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0
// HA2 aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxl
// HA2 bmRFbnRyeS5UZXh0dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWYFWRpZmZ1
// HA2 c2VfdGVzdDAxXzAyLnBuZwQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWYFEJsZW5kRGlmZnVzZTBU
// HA2 ZXh0dXJlAQEBQApCbGVuZEVudHJ5BAlJc0VuYWJsZWSYBFRydWUECklzU3BlY3VsYXKYBUZhbHNl
// HA2 BApQYXJhbWV0ZXJYmBBIYWxmVmVjdG9yTm9ybWFsBApQYXJhbWV0ZXJZmAROb25lQBJCbGVuZEVu
// HA2 dHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtpbmSY
// HA2 CE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyYA1JlZAFAC0Js
// HA2 ZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRhcmdl
// HA2 dENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJD
// HA2 aGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1cmVA
// HA2 B1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhGaWxlTmFtZZgSZGlmZnVzZV90ZXN0MDMucG5nBARL
// HA2 aW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgUQmxlbmREaWZmdXNlMVRleHR1cmUBAQFACkJsZW5kRW50
// HA2 cnkECUlzRW5hYmxlZJgFRmFsc2UECklzU3BlY3VsYXKYBUZhbHNlBApQYXJhbWV0ZXJYmAtMaWdo
// HA2 dE5vcm1hbAQKUGFyYW1ldGVyWZgKU2F0dXJhdGlvbkASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJh
// HA2 eQQEVHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1l
// HA2 dGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVsmANSZWQBQAtCbGVuZEFjdGlvbgQES2luZJgI
// HA2 TXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBUdyZWVuBA1UYXJnZXRDaGFubmVsmAVHcmVlbgFA
// HA2 C0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgEQmx1ZQQNVGFy
// HA2 Z2V0Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5UZXh0dXJlQAdUZXh0dXJlBAROYW1lmAh7
// HA2 eDpOdWxsfQQIRmlsZU5hbWWYE0RpZmZ1c2VNdWxCeVNhdC5wbmcEBEtpbmSYA1JnYgQMVmFyaWFi
// HA2 bGVOYW1lmBRCbGVuZERpZmZ1c2UyVGV4dHVyZQEBAQFAGkVmZmVjdERvY3VtZW50LkVkZ2VFbnRy
// HA2 aWVzQApCbGVuZEVudHJ5BAlJc0VuYWJsZWSYBFRydWUECklzU3BlY3VsYXKYBUZhbHNlBApQYXJh
// HA2 bWV0ZXJYmAROb25lBApQYXJhbWV0ZXJZmAROb25lQBJCbGVuZEVudHJ5LkFjdGlvbnN1BUFycmF5
// HA2 BARUeXBlmAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0
// HA2 ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyYA1JlZAFAC0JsZW5kQWN0aW9uBARLaW5kmAhN
// HA2 dWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUAL
// HA2 QmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJn
// HA2 ZXRDaGFubmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1cmVAB1RleHR1cmUECEZpbGVOYW1l
// HA2 mAh7eDpOdWxsfQQETmFtZZgIe3g6TnVsbH0EBEtpbmSYA1JnYgQMVmFyaWFibGVOYW1lmBFCbGVu
// HA2 ZEVkZ2UwVGV4dHVyZQEBAQFAHkVmZmVjdERvY3VtZW50LlNwZWN1bGFyRW50cmllc0AKQmxlbmRF
// HA2 bnRyeQQJSXNFbmFibGVkmAVGYWxzZQQKSXNTcGVjdWxhcpgEVHJ1ZQQKUGFyYW1ldGVyWJgNU3Bl
// HA2 Y3VsYXJWYWx1ZQQKUGFyYW1ldGVyWZgETm9uZUASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQE
// HA2 VHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVy
// HA2 Q2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVsmANSZWQBQAtCbGVuZEFjdGlvbgQES2luZJgITXVs
// HA2 dGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBUdyZWVuBA1UYXJnZXRDaGFubmVsmAVHcmVlbgFAC0Js
// HA2 ZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFyYW1ldGVyQ2hhbm5lbJgEQmx1ZQQNVGFyZ2V0
// HA2 Q2hhbm5lbJgEQmx1ZQEBAUASQmxlbmRFbnRyeS5UZXh0dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpO
// HA2 dWxsfQQIRmlsZU5hbWWYD1NwZWN1bGFyTXVsLnBuZwQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWY
// HA2 FUJsZW5kU3BlY3VsYXIwVGV4dHVyZQEBAQEB