#include "HAHead.hlsl"

//#define BLENDDIFFUSE0TEXTUREFILENAME "diffuse_test01.png"
#define BLENDDIFFUSE1TEXTUREFILENAME "diffuse_test02.png"
//#define BLENDDIFFUSE2TEXTUREFILENAME "DiffuseMulBySat.png"
//#define BLENDSPECULAR0TEXTUREFILENAME "SpecularMul.png"
//#define BLENDADDSPHERE0TEXTUREFILENAME "AddSphereRepl.png"
#define BLENDEDGE0TEXTUREFILENAME
#define USE_EXCELLENTSHADOW
//#define SHADE_TOONLESS
//#define AMBIENT_AS_BASE
//#define AMBIENT_TOON_AS_BASE
#define HANDLE_EDGE
//#define FIX_LIGHTDIR
//#define FIX_SPHEREMAP
#ifdef BLENDDIFFUSE0TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, BLENDDIFFUSE0TEXTUREFILENAME)
#endif
#ifdef BLENDDIFFUSE1TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendDiffuse1Texture, BlendDiffuse1TextureSampler, BLENDDIFFUSE1TEXTUREFILENAME)
#endif
#ifdef BLENDDIFFUSE2TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendDiffuse2Texture, BlendDiffuse2TextureSampler, BLENDDIFFUSE2TEXTUREFILENAME)
#endif
#ifdef BLENDSPECULAR0TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendSpecular0Texture, BlendSpecular0TextureSampler, BLENDSPECULAR0TEXTUREFILENAME)
#endif
#ifdef BLENDADDSPHERE0TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendAddSphere0Texture, BlendAddSphere0TextureSampler, BLENDADDSPHERE0TEXTUREFILENAME)
#endif

float EdgeWidthRate
<
	string UIName = "GbW";
	float UIMin = 0;
	float UIMax = 2;
> = 0.7;

float3 BlendDiffuse0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE0TEXTUREFILENAME
	float4 value = tex2D(BlendDiffuse0TextureSampler, float2(parameters.LightNormal, 0));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse1(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE1TEXTUREFILENAME
	float4 value = tex2D(BlendDiffuse1TextureSampler, float2(parameters.LightNormal, 0));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse2(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE2TEXTUREFILENAME
	float3 targetHsv = GetHsvFromRgb(target);
	float4 value = tex2D(BlendDiffuse2TextureSampler, float2(parameters.LightNormal, targetHsv.y));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse(float3 color, BlendParameters parameters)
{
	color = BlendDiffuse0(color, parameters);
	color = BlendDiffuse1(color, parameters);
	color = BlendDiffuse2(color, parameters);

	return color;
}

float3 BlendSpecular0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDSPECULAR0TEXTUREFILENAME
	float4 value = tex2D(BlendSpecular0TextureSampler, float2(parameters.SpecularValue, 0));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendSpecular(float3 color, BlendParameters parameters)
{
	color = BlendSpecular0(color, parameters);

	return color;
}

float3 BlendAddSphere0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDADDSPHERE0TEXTUREFILENAME
	float3 targetHsv = GetHsvFromRgb(target);
	float4 value = tex2D(BlendAddSphere0TextureSampler, float2(targetHsv.z, 0));
	
	targetHsv.z = lerp(targetHsv.z, value.b, value.a);
	target = GetRgbFromHsv(targetHsv);
	#endif
	
	return target;
}

float3 BlendAddSphere(float3 color, BlendParameters parameters)
{
	color = BlendAddSphere0(color, parameters);

	return color;
}

float3 BlendEdge0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDEDGE0TEXTUREFILENAME
	float4 value = float4(0, 0, 0, 1);
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendEdge(float3 color, BlendParameters parameters)
{
	color = BlendEdge0(color, parameters);

	return color;
}

#include "HACore.hlsl"

// HAGenerator Document
// HA2 QA5FZmZlY3REb2N1bWVudAQVQ29weUNvcmVUb0Rlc3RpbmF0aW9umARUcnVlBAlFZGdlV2lkdGiY
// HA2 AzAuNwQRRml4TGlnaHREaXJlY3Rpb26YBUZhbHNlBAxGaXhTcGhlcmVNYXCYBUZhbHNlBApIYW5k
// HA2 bGVFZGdlmARUcnVlBBBTZXRBbWJpZW50QXNCYXNlmAVGYWxzZQQYU2V0QW1iaWVudEFzQmFzZVdp
// HA2 dGhUb29umAVGYWxzZQQNU2hhZGVUb29ubGVzc5gFRmFsc2UEElVzZUV4Y2VsbGVudFNoYWRvd5gE
// HA2 VHJ1ZQg5Y2xyLW5hbWVzcGFjZTpMaW5lYXJzdGFyLkhBR2VuZXJhdG9yO2Fzc2VtYmx5PUhBR2Vu
// HA2 ZXJhdG9yCQF4LGh0dHA6Ly9zY2hlbWFzLm1pY3Jvc29mdC5jb20vd2luZngvMjAwNi94YW1sQB9F
// HA2 ZmZlY3REb2N1bWVudC5BZGRTcGhlcmVFbnRyaWVzQApCbGVuZEVudHJ5BAlJc0VuYWJsZWSYBUZh
// HA2 bHNlBApJc1NwZWN1bGFymARUcnVlBApQYXJhbWV0ZXJYmAVWYWx1ZQQKUGFyYW1ldGVyWZgETm9u
// HA2 ZUASQmxlbmRFbnRyeS5BY3Rpb25zdQVBcnJheQQEVHlwZZgLQmxlbmRBY3Rpb25AC0JsZW5kQWN0
// HA2 aW9uBARLaW5kmAROb25lBBBQYXJhbWV0ZXJDaGFubmVsmANSZWQEDVRhcmdldENoYW5uZWyYA0h1
// HA2 ZQFAC0JsZW5kQWN0aW9uBARLaW5kmAROb25lBBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFy
// HA2 Z2V0Q2hhbm5lbJgKU2F0dXJhdGlvbgFAC0JsZW5kQWN0aW9uBARLaW5kmAdSZXBsYWNlBBBQYXJh
// HA2 bWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmAVWYWx1ZQEBAUASQmxlbmRFbnRyeS5U
// HA2 ZXh0dXJlQAdUZXh0dXJlBAROYW1lmAh7eDpOdWxsfQQIRmlsZU5hbWWYEUFkZFNwaGVyZVJlcGwu
// HA2 cG5nBARLaW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgWQmxlbmRBZGRTcGhlcmUwVGV4dHVyZQEBAQFA
// HA2 HUVmZmVjdERvY3VtZW50LkRpZmZ1c2VFbnRyaWVzQApCbGVuZEVudHJ5BAlJc0VuYWJsZWSYBUZh
// HA2 bHNlBApJc1NwZWN1bGFymAVGYWxzZQQKUGFyYW1ldGVyWJgLTGlnaHROb3JtYWwEClBhcmFtZXRl
// HA2 clmYBE5vbmVAEkJsZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtC
// HA2 bGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0
// HA2 Q2hhbm5lbJgDUmVkAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFu
// HA2 bmVsmAVHcmVlbgQNVGFyZ2V0Q2hhbm5lbJgFR3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgITXVs
// HA2 dGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBEJsdWUEDVRhcmdldENoYW5uZWyYBEJsdWUBAQFAEkJs
// HA2 ZW5kRW50cnkuVGV4dHVyZUAHVGV4dHVyZQQETmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lmBJkaWZm
// HA2 dXNlX3Rlc3QwMS5wbmcEBEtpbmSYA1JnYgQMVmFyaWFibGVOYW1lmBRCbGVuZERpZmZ1c2UwVGV4
// HA2 dHVyZQEBAUAKQmxlbmRFbnRyeQQJSXNFbmFibGVkmARUcnVlBApJc1NwZWN1bGFymAVGYWxzZQQK
// HA2 UGFyYW1ldGVyWJgLTGlnaHROb3JtYWwEClBhcmFtZXRlclmYBE5vbmVAEkJsZW5kRW50cnkuQWN0
// HA2 aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlw
// HA2 bHkEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hhbm5lbJgDUmVkAUALQmxlbmRBY3Rp
// HA2 b24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFyZ2V0Q2hhbm5l
// HA2 bJgFR3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyY
// HA2 BEJsdWUEDVRhcmdldENoYW5uZWyYBEJsdWUBAQFAEkJsZW5kRW50cnkuVGV4dHVyZUAHVGV4dHVy
// HA2 ZQQETmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lmBJkaWZmdXNlX3Rlc3QwMi5wbmcEBEtpbmSYA1Jn
// HA2 YgQMVmFyaWFibGVOYW1lmBRCbGVuZERpZmZ1c2UxVGV4dHVyZQEBAUAKQmxlbmRFbnRyeQQJSXNF
// HA2 bmFibGVkmAVGYWxzZQQKSXNTcGVjdWxhcpgFRmFsc2UEClBhcmFtZXRlcliYC0xpZ2h0Tm9ybWFs
// HA2 BApQYXJhbWV0ZXJZmApTYXR1cmF0aW9uQBJCbGVuZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBl
// HA2 mAtCbGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFu
// HA2 bmVsmANSZWQEDVRhcmdldENoYW5uZWyYA1JlZAFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBs
// HA2 eQQQUGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRB
// HA2 Y3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFu
// HA2 bmVsmARCbHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9
// HA2 BAhGaWxlTmFtZZgTRGlmZnVzZU11bEJ5U2F0LnBuZwQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWY
// HA2 FEJsZW5kRGlmZnVzZTJUZXh0dXJlAQEBAUAaRWZmZWN0RG9jdW1lbnQuRWRnZUVudHJpZXNACkJs
// HA2 ZW5kRW50cnkECUlzRW5hYmxlZJgEVHJ1ZQQKSXNTcGVjdWxhcpgFRmFsc2UEClBhcmFtZXRlcliY
// HA2 BE5vbmUEClBhcmFtZXRlclmYBE5vbmVAEkJsZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWY
// HA2 C0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5u
// HA2 ZWyYA1JlZAQNVGFyZ2V0Q2hhbm5lbJgDUmVkAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5
// HA2 BBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFyZ2V0Q2hhbm5lbJgFR3JlZW4BQAtCbGVuZEFj
// HA2 dGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBEJsdWUEDVRhcmdldENoYW5u
// HA2 ZWyYBEJsdWUBAQFAEkJsZW5kRW50cnkuVGV4dHVyZUAHVGV4dHVyZQQIRmlsZU5hbWWYCHt4Ok51
// HA2 bGx9BAROYW1lmAh7eDpOdWxsfQQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWYEUJsZW5kRWRnZTBU
// HA2 ZXh0dXJlAQEBAUAeRWZmZWN0RG9jdW1lbnQuU3BlY3VsYXJFbnRyaWVzQApCbGVuZEVudHJ5BAlJ
// HA2 c0VuYWJsZWSYBUZhbHNlBApJc1NwZWN1bGFymARUcnVlBApQYXJhbWV0ZXJYmA1TcGVjdWxhclZh
// HA2 bHVlBApQYXJhbWV0ZXJZmAROb25lQBJCbGVuZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtC
// HA2 bGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVs
// HA2 mANSZWQEDVRhcmdldENoYW5uZWyYA1JlZAFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQ
// HA2 UGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rp
// HA2 b24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVs
// HA2 mARCbHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhG
// HA2 aWxlTmFtZZgPU3BlY3VsYXJNdWwucG5nBARLaW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgVQmxlbmRT
// HA2 cGVjdWxhcjBUZXh0dXJlAQEBAQE=