#include "HAHead.hlsl"

#define BLENDDIFFUSE0TEXTUREFILENAME "diffuse_headset01.png"
//#define BLENDDIFFUSE1TEXTUREFILENAME "diffuse_test03.png"
//#define BLENDDIFFUSE2TEXTUREFILENAME "DiffuseMulBySat.png"
//#define BLENDSPECULAR0TEXTUREFILENAME "SpecularMul.png"
//#define BLENDADDSPHERE0TEXTUREFILENAME "AddSphereRepl.png"
#define BLENDEDGE0TEXTUREFILENAME
#define USE_EXCELLENTSHADOW
//#define SHADE_TOONLESS
//#define AMBIENT_AS_BASE
//#define AMBIENT_TOON_AS_BASE
//#define HANDLE_EDGE
//#define FIX_LIGHTDIR
//#define FIX_SPHEREMAP
#ifdef BLENDDIFFUSE0TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendDiffuse0Texture, BlendDiffuse0TextureSampler, BLENDDIFFUSE0TEXTUREFILENAME)
#endif
#ifdef BLENDDIFFUSE1TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendDiffuse1Texture, BlendDiffuse1TextureSampler, BLENDDIFFUSE1TEXTUREFILENAME)
#endif
#ifdef BLENDDIFFUSE2TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendDiffuse2Texture, BlendDiffuse2TextureSampler, BLENDDIFFUSE2TEXTUREFILENAME)
#endif
#ifdef BLENDSPECULAR0TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendSpecular0Texture, BlendSpecular0TextureSampler, BLENDSPECULAR0TEXTUREFILENAME)
#endif
#ifdef BLENDADDSPHERE0TEXTUREFILENAME
DEFINE_TEXTURE_SAMPLER(BlendAddSphere0Texture, BlendAddSphere0TextureSampler, BLENDADDSPHERE0TEXTUREFILENAME)
#endif

float EdgeWidthRate
<
	string UIName = "GbW";
	float UIMin = 0;
	float UIMax = 2;
> = 0.7;

float3 BlendDiffuse0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE0TEXTUREFILENAME
	float4 value = tex2D(BlendDiffuse0TextureSampler, float2(parameters.LightNormal, 0));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse1(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE1TEXTUREFILENAME
	float4 value = tex2D(BlendDiffuse1TextureSampler, float2(0, 0));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse2(float3 target, BlendParameters parameters)
{
	#ifdef BLENDDIFFUSE2TEXTUREFILENAME
	float3 targetHsv = GetHsvFromRgb(target);
	float4 value = tex2D(BlendDiffuse2TextureSampler, float2(parameters.LightNormal, targetHsv.y));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendDiffuse(float3 color, BlendParameters parameters)
{
	color = BlendDiffuse0(color, parameters);
	color = BlendDiffuse1(color, parameters);
	color = BlendDiffuse2(color, parameters);

	return color;
}

float3 BlendSpecular0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDSPECULAR0TEXTUREFILENAME
	float4 value = tex2D(BlendSpecular0TextureSampler, float2(parameters.SpecularValue, 0));
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendSpecular(float3 color, BlendParameters parameters)
{
	color = BlendSpecular0(color, parameters);

	return color;
}

float3 BlendAddSphere0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDADDSPHERE0TEXTUREFILENAME
	float3 targetHsv = GetHsvFromRgb(target);
	float4 value = tex2D(BlendAddSphere0TextureSampler, float2(targetHsv.z, 0));
	
	targetHsv.z = lerp(targetHsv.z, value.b, value.a);
	target = GetRgbFromHsv(targetHsv);
	#endif
	
	return target;
}

float3 BlendAddSphere(float3 color, BlendParameters parameters)
{
	color = BlendAddSphere0(color, parameters);

	return color;
}

float3 BlendEdge0(float3 target, BlendParameters parameters)
{
	#ifdef BLENDEDGE0TEXTUREFILENAME
	float4 value = float4(0, 0, 0, 1);
	
	target.r = lerp(target.r, target.r * value.r, value.a);
	target.g = lerp(target.g, target.g * value.g, value.a);
	target.b = lerp(target.b, target.b * value.b, value.a);
	#endif
	
	return target;
}

float3 BlendEdge(float3 color, BlendParameters parameters)
{
	color = BlendEdge0(color, parameters);

	return color;
}

#include "HACore.hlsl"

// HAGenerator Document
// HA2 QA5FZmZlY3REb2N1bWVudAQVQ29weUNvcmVUb0Rlc3RpbmF0aW9umARUcnVlBAlFZGdlV2lkdGiY
// HA2 AzAuNwQRRml4TGlnaHREaXJlY3Rpb26YBUZhbHNlBAxGaXhTcGhlcmVNYXCYBUZhbHNlBApIYW5k
// HA2 bGVFZGdlmAVGYWxzZQQQU2V0QW1iaWVudEFzQmFzZZgFRmFsc2UEGFNldEFtYmllbnRBc0Jhc2VX
// HA2 aXRoVG9vbpgFRmFsc2UEDVNoYWRlVG9vbmxlc3OYBUZhbHNlBBJVc2VFeGNlbGxlbnRTaGFkb3eY
// HA2 BFRydWUIOWNsci1uYW1lc3BhY2U6TGluZWFyc3Rhci5IQUdlbmVyYXRvcjthc3NlbWJseT1IQUdl
// HA2 bmVyYXRvcgkBeCxodHRwOi8vc2NoZW1hcy5taWNyb3NvZnQuY29tL3dpbmZ4LzIwMDYveGFtbEAf
// HA2 RWZmZWN0RG9jdW1lbnQuQWRkU3BoZXJlRW50cmllc0AKQmxlbmRFbnRyeQQJSXNFbmFibGVkmAVG
// HA2 YWxzZQQKSXNTcGVjdWxhcpgEVHJ1ZQQKUGFyYW1ldGVyWJgFVmFsdWUEClBhcmFtZXRlclmYBE5v
// HA2 bmVAEkJsZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFj
// HA2 dGlvbgQES2luZJgETm9uZQQQUGFyYW1ldGVyQ2hhbm5lbJgDUmVkBA1UYXJnZXRDaGFubmVsmANI
// HA2 dWUBQAtCbGVuZEFjdGlvbgQES2luZJgETm9uZQQQUGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRh
// HA2 cmdldENoYW5uZWyYClNhdHVyYXRpb24BQAtCbGVuZEFjdGlvbgQES2luZJgHUmVwbGFjZQQQUGFy
// HA2 YW1ldGVyQ2hhbm5lbJgEQmx1ZQQNVGFyZ2V0Q2hhbm5lbJgFVmFsdWUBAQFAEkJsZW5kRW50cnku
// HA2 VGV4dHVyZUAHVGV4dHVyZQQETmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lmBFBZGRTcGhlcmVSZXBs
// HA2 LnBuZwQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWYFkJsZW5kQWRkU3BoZXJlMFRleHR1cmUBAQEB
// HA2 QB1FZmZlY3REb2N1bWVudC5EaWZmdXNlRW50cmllc0AKQmxlbmRFbnRyeQQJSXNFbmFibGVkmARU
// HA2 cnVlBApJc1NwZWN1bGFymAVGYWxzZQQKUGFyYW1ldGVyWJgLTGlnaHROb3JtYWwEClBhcmFtZXRl
// HA2 clmYBE5vbmVAEkJsZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtC
// HA2 bGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0
// HA2 Q2hhbm5lbJgDUmVkAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFu
// HA2 bmVsmAVHcmVlbgQNVGFyZ2V0Q2hhbm5lbJgFR3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgITXVs
// HA2 dGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBEJsdWUEDVRhcmdldENoYW5uZWyYBEJsdWUBAQFAEkJs
// HA2 ZW5kRW50cnkuVGV4dHVyZUAHVGV4dHVyZQQETmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lmBVkaWZm
// HA2 dXNlX2hlYWRzZXQwMS5wbmcEBEtpbmSYA1JnYgQMVmFyaWFibGVOYW1lmBRCbGVuZERpZmZ1c2Uw
// HA2 VGV4dHVyZQEBAUAKQmxlbmRFbnRyeQQJSXNFbmFibGVkmAVGYWxzZQQKSXNTcGVjdWxhcpgFRmFs
// HA2 c2UEClBhcmFtZXRlcliYBE5vbmUEClBhcmFtZXRlclmYBE5vbmVAEkJsZW5kRW50cnkuQWN0aW9u
// HA2 c3UFQXJyYXkEBFR5cGWYC0JsZW5kQWN0aW9uQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkE
// HA2 EFBhcmFtZXRlckNoYW5uZWyYA1JlZAQNVGFyZ2V0Q2hhbm5lbJgDUmVkAUALQmxlbmRBY3Rpb24E
// HA2 BEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFyZ2V0Q2hhbm5lbJgF
// HA2 R3JlZW4BQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBEJs
// HA2 dWUEDVRhcmdldENoYW5uZWyYBEJsdWUBAQFAEkJsZW5kRW50cnkuVGV4dHVyZUAHVGV4dHVyZQQE
// HA2 TmFtZZgIe3g6TnVsbH0ECEZpbGVOYW1lmBJkaWZmdXNlX3Rlc3QwMy5wbmcEBEtpbmSYA1JnYgQM
// HA2 VmFyaWFibGVOYW1lmBRCbGVuZERpZmZ1c2UxVGV4dHVyZQEBAUAKQmxlbmRFbnRyeQQJSXNFbmFi
// HA2 bGVkmAVGYWxzZQQKSXNTcGVjdWxhcpgFRmFsc2UEClBhcmFtZXRlcliYC0xpZ2h0Tm9ybWFsBApQ
// HA2 YXJhbWV0ZXJZmApTYXR1cmF0aW9uQBJCbGVuZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtC
// HA2 bGVuZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVs
// HA2 mANSZWQEDVRhcmdldENoYW5uZWyYA1JlZAFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQ
// HA2 UGFyYW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rp
// HA2 b24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVs
// HA2 mARCbHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhG
// HA2 aWxlTmFtZZgTRGlmZnVzZU11bEJ5U2F0LnBuZwQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWYFEJs
// HA2 ZW5kRGlmZnVzZTJUZXh0dXJlAQEBAUAaRWZmZWN0RG9jdW1lbnQuRWRnZUVudHJpZXNACkJsZW5k
// HA2 RW50cnkECUlzRW5hYmxlZJgEVHJ1ZQQKSXNTcGVjdWxhcpgFRmFsc2UEClBhcmFtZXRlcliYBE5v
// HA2 bmUEClBhcmFtZXRlclmYBE5vbmVAEkJsZW5kRW50cnkuQWN0aW9uc3UFQXJyYXkEBFR5cGWYC0Js
// HA2 ZW5kQWN0aW9uQAtCbGVuZEFjdGlvbgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyY
// HA2 A1JlZAQNVGFyZ2V0Q2hhbm5lbJgDUmVkAUALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQ
// HA2 YXJhbWV0ZXJDaGFubmVsmAVHcmVlbgQNVGFyZ2V0Q2hhbm5lbJgFR3JlZW4BQAtCbGVuZEFjdGlv
// HA2 bgQES2luZJgITXVsdGlwbHkEEFBhcmFtZXRlckNoYW5uZWyYBEJsdWUEDVRhcmdldENoYW5uZWyY
// HA2 BEJsdWUBAQFAEkJsZW5kRW50cnkuVGV4dHVyZUAHVGV4dHVyZQQIRmlsZU5hbWWYCHt4Ok51bGx9
// HA2 BAROYW1lmAh7eDpOdWxsfQQES2luZJgDUmdiBAxWYXJpYWJsZU5hbWWYEUJsZW5kRWRnZTBUZXh0
// HA2 dXJlAQEBAUAeRWZmZWN0RG9jdW1lbnQuU3BlY3VsYXJFbnRyaWVzQApCbGVuZEVudHJ5BAlJc0Vu
// HA2 YWJsZWSYBUZhbHNlBApJc1NwZWN1bGFymARUcnVlBApQYXJhbWV0ZXJYmA1TcGVjdWxhclZhbHVl
// HA2 BApQYXJhbWV0ZXJZmAROb25lQBJCbGVuZEVudHJ5LkFjdGlvbnN1BUFycmF5BARUeXBlmAtCbGVu
// HA2 ZEFjdGlvbkALQmxlbmRBY3Rpb24EBEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmANS
// HA2 ZWQEDVRhcmdldENoYW5uZWyYA1JlZAFAC0JsZW5kQWN0aW9uBARLaW5kmAhNdWx0aXBseQQQUGFy
// HA2 YW1ldGVyQ2hhbm5lbJgFR3JlZW4EDVRhcmdldENoYW5uZWyYBUdyZWVuAUALQmxlbmRBY3Rpb24E
// HA2 BEtpbmSYCE11bHRpcGx5BBBQYXJhbWV0ZXJDaGFubmVsmARCbHVlBA1UYXJnZXRDaGFubmVsmARC
// HA2 bHVlAQEBQBJCbGVuZEVudHJ5LlRleHR1cmVAB1RleHR1cmUEBE5hbWWYCHt4Ok51bGx9BAhGaWxl
// HA2 TmFtZZgPU3BlY3VsYXJNdWwucG5nBARLaW5kmANSZ2IEDFZhcmlhYmxlTmFtZZgVQmxlbmRTcGVj
// HA2 dWxhcjBUZXh0dXJlAQEBAQE=